#include <ZumoBuzzer.h>
#include <ZumoMotors.h>

ZumoMotors motors;
ZumoBuzzer buzzer;

const char sound_effect[] PROGMEM = "O4 T100 V15 L4 MS g12>c12>e12>G6>E12 ML>G2";

String inputString = "";         // a string to hold incoming data
String bufString = "";

void setup() {
  pinMode(13, OUTPUT);
  digitalWrite(13, HIGH);

  Serial.begin(19200);

  inputString.reserve(200);
  bufString.reserve(10);

  buzzer.playMode(PLAY_AUTOMATIC);

  delay(1000);

  int i;
  for(i = 0; i < 80; i++) {
    if ((i > 10 && i <= 30) || (i > 50 && i <= 70)) {
      motors.setSpeeds(-200, 200);
    } else {
      motors.setSpeeds(200, -200);
    }
    delay(20);
  }
  motors.setSpeeds(0,0);

  digitalWrite(13, LOW);

  buzzer.playFromProgramSpace(sound_effect);
  delay(1000);
}

void loop() {
  if (Serial.available() > 0) {
    char inChar = Serial.read();
    inputString += inChar;
    if (inChar == '\n') {
      data_rcv();
      inputString = "";
      bufString = "";
    }
  }
}

void data_rcv(void)
{
  char **e;

  delay(4);
  int dataindex = inputString.indexOf(':') + 1;
  bufString = inputString.substring(dataindex, (dataindex + 2));
  const char *s = bufString.c_str();
  int data = (int)strtol(s, e, 16);

  switch (data) {
    case 0x01:  // Next
      motors.setSpeeds(200, -200);
      break;
    case 0x02:  // Before
      motors.setSpeeds(-200, 200);
      break;
    case 0x04:  // Inc
      motors.setSpeeds(200, 200);
      break;
    case 0x08:  // Dec
      motors.setSpeeds(-200, -200);
      break;
    case 0x10:  // Sel
      motors.setSpeeds(0 , 0);
      break;
    default:
      ;
  }
  delay(100);
}
